# Copyright 2021-2023 H2020 TeraFlow (https://www.teraflow-h2020.eu/)
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

apiVersion: apps/v1
kind: Deployment
metadata:
  name: webuiservice
spec:
  selector:
    matchLabels:
      app: webuiservice
  template:
    metadata:
      labels:
        app: webuiservice
    spec:
      terminationGracePeriodSeconds: 5
      securityContext:
        fsGroup: 472
        supplementalGroups:
          - 0
      containers:
      - name: server
        image: registry.gitlab.com/teraflow-h2020/controller/webui:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 8004 # TODO: define the real port
        env:
        - name: LOG_LEVEL
          value: "DEBUG"
        - name: WEBUISERVICE_SERVICE_BASEURL_HTTP
          value: "/webui"
        readinessProbe:
          httpGet:
            path: /healthz/ready
            port: 8004
          initialDelaySeconds: 5
          timeoutSeconds: 1
        livenessProbe:
          httpGet:
            path: /healthz/live
            port: 8004
          initialDelaySeconds: 5
          timeoutSeconds: 1
        resources:
          requests:
            cpu: 250m
            memory: 512Mi
          limits:
            cpu: 700m
            memory: 1024Mi
#      - name: grafana
#        image: grafana/grafana:8.2.6
#        imagePullPolicy: IfNotPresent
#        ports:
#          - containerPort: 3000
#            name: http-grafana
#            protocol: TCP
#        env:
#        - name: GF_SERVER_ROOT_URL
#          value: "http://0.0.0.0:3000/grafana/"
#        - name: GF_SERVER_SERVE_FROM_SUB_PATH
#          value: "true"
#        readinessProbe:
#          failureThreshold: 3
#          httpGet:
#            path: /robots.txt
#            port: 3000
#            scheme: HTTP
#          initialDelaySeconds: 10
#          periodSeconds: 30
#          successThreshold: 1
#          timeoutSeconds: 2
#        livenessProbe:
#          failureThreshold: 3
#          initialDelaySeconds: 30
#          periodSeconds: 10
#          successThreshold: 1
#          tcpSocket:
#            port: 3000
#          timeoutSeconds: 1
#        resources:
#          requests:
#            cpu: 250m
#            memory: 750Mi
#          limits:
#            cpu: 700m
#            memory: 1024Mi
---
apiVersion: v1
kind: Service
metadata:
  name: webuiservice
spec:
  type: ClusterIP
  selector:
    app: webuiservice
  ports:
  - name: webui
    port: 8004
    targetPort: 8004
#  - name: grafana
#    port: 3000
#    targetPort: 3000
